%%%%%%%%%%%%%%%%%%%%%% p2_9.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%              last revision: 5/23/99 HS
%----------------------------------------------------
% 		    Problem 2.9: find zeros, poles, gain  
%          of a tf model, and perform PFE.
% Computes impulse response as sum of individual
%       functions and plots impulse response
%----------------------------------------------------
clear, clf
disp('Problem 2.9 - Third-order system with one repeated pole')
numG = [6 4]
denG = [1 3.75 4.5 1.6875]
G = tf(numG,denG)
disp('*****>');pause
GG = zpk(G)
disp('*****>');pause
[zG,pG,kG] = zpkdata(G,'v')
disp('*****>');pause
[resG,polG,otherG] = residue(numG,denG)
disp('*****>');pause
t = [0:0.05:10]';
g1 = rpole2t(polG(1),resG(1),t);
g2 = t.*rpole2t(polG(2),resG(2),t);
g3 = rpole2t(polG(3),resG(3),t);
plot(t,g1,'--',t,g2,'-.',t,g3); grid
title('P2.9: Individual Responses of Repeated Pole (- - and -.-.) and Real Pole')
keyboard
y = impulse(numG,denG,t);
plot(t,y)
grid;title('P2.9: g(t) from G(s) with repeated pole')
xlabel('Time (seconds)')
disp('end of Reinforcement Problem 2.9')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
