%%%%%%%%%%%%%%%%%%%%% wif2_8a.m %%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/23/99 HS
%---------------------------------------------------- 
%     What If for Example 2.8, part a:  
%  determine poles, zeros, and stability of system 
%          with pole at origin
%----------------------------------------------------
clear, clf
disp('What If 2.8(a): Poles and system stability')
disp(' ')
numG = [1.5 1]
denG = [1 2 2.5 0]
disp('*****>');pause
disp('zeros:')
zGroots = roots(numG)
disp('poles:')
pGroots = roots(denG)
disp('*****>');pause
G = tf(numG,denG)
pG = pole(G)
disp('*****>');pause
disp('System is marginally stable because all the poles')
disp('....are in the left half-plane except for one pole')
disp('....at s = 0. The impulse-response plot shows that ')
disp('....the impulse response approaches a nonzero constant.')
disp('*****>');pause
pzmap(G); grid
axis([-1.5 0.5 -1.5 1.5]);
title('WIF2.8a: pole-zero map')
keyboard
T = [0:0.01:6]';
impulse(G,T); grid
title('WIF2.8a: impulse response')
disp('Can you use the final-value theorem to calculate')
disp('....the steady-state value of the impulse reponse?')
disp('end of What If 2.8a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%