%%%%%%%%%%%%%%%%%%%%%% cp3_2b.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/25/99 HS
%----------------------------------------------------
%            Comprehensive Problem CP3.2b
%    Satellite with lead, does ref step response
%----------------------------------------------------
disp('CP3.2B: Satellite with lead, does ref step response')
clear;clf
% load sat.mat if exists, otherwise quit this M-file
if chkmat('sat') == 1, 
    load sat.mat
  else
    return
end
%
numGp = numG1;	% plant model in TF form for tau_m --> theta
denGp = denG1;
Gp = tf(numGp,denGp)
disp('A reasonable value is Klead = -0.001')
Klead = input('enter lead gain (<0) ==>')
Klead_str = num2str(Klead);
disp('A reasonable value is Zlead = -0.02')
Zlead = input('enter lead zero (<0) ==>')
Zlead_str = num2str(Zlead);
disp('A reasonable value is alpha = 20')
Alead = input('enter lead alpha ==>')
Alead_str = num2str(Alead);	
%------ use Eq 3.3 for lead TF
numGc = Klead*[1  -Zlead];
denGc = [1  -Alead*Zlead];
Gc = tf(numGc,denGc)
%------- forward transfer function is Gc * Gp
G_OL = Gc*Gp
%---- closed-loop TF with H(s) = 1
G_CL = feedback(G_OL,1)
disp('closed-loop zeros, poles & DC gain are:')
[zCL,pCL,kCL]=zpkdata(G_CL,'v')
disp('*******>');pause
%---- run for 1000 sec
t = [0:2:1000]';
y = step(G_CL,t);
plot(t,y);grid
xlabel('Time (secs)'); ylabel('Pointing angle (deg)')
title('CP3.2b: satellite with lead, step in theta_des')
text('Units','Norm','Pos',[0.6 0.25],'String',...
			['Klead = ' Klead_str])
text('Units','Norm','Pos',[0.6 0.15],'String',...
			['Zlead = ' Zlead_str])
text('Units','Norm','Pos',[0.6 0.05],'String',...
			['Alead = ' Alead_str])
disp('end of Comprehensive Problem 3.2b')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%