%%%%%%%%%%%%%%%%%%%%%% cp4_1.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%  .M file for analyzing the power system example for 
%             Comprehensive Problem CP4.1
%----------------------------------------------------
clear, clf
disp('Comprehensive Problem CP4.1')

epow % read data

disp('Power system model state matrices, with Vterminal as output')
D1 = 0; 
A, B, C1, D1 
disp('*****>'), pause

disp('Lag controller gain array') 
K_lag = [10 20 30 40 50 60]'
len_Klag = length(K_lag);
disp('*****>'), pause

for i = 1:len_Klag
 disp('investigate the controller performance for K_lag = ')
 K_lag(i) 
 z_lag = -1
 p_lag = z_lag/10
 disp('controller transfer function')
 Gss =ss(A,B,C1,D1)
 num_lag = K_lag(i)*[1 -z_lag]
 den_lag = [1 -p_lag]
 Glag = tf(num_lag,den_lag)
 disp('*****>'), pause
 disp('convert controller to ss form')
 Glagss = ss(Glag)
 disp('*****>'), pause
 Gf = Gss*Glagss;
 disp('Closed-loop system in ss form')
 GfCL = feedback(Gf,1)
 [A_CL,B_CL,C_CL,D_CL] = ssdata(GfCL)
 disp('*****>'), pause
 disp('poles of the close loop system')
 p=pole(GfCL)
 disp('zeros of the close loop system using tzero')
 z=tzero(GfCL)
 disp('*****>'), pause
 disp('step response')
 step(GfCL)
 grid;title('CP4.1: Power system model step response with lag controller')
 text('Units','Norm','Pos',[0.6 0.25],'String',['Klag = ' num2str(K_lag(i))])
 keyboard
end

disp('end of Comprehensive Problem 4.1')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

