%%%%%%%%%%%%%%%%%%%%%% cp5_4c.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%   .M file for analyzing the hydro-turbine system 
%      example for Comprehensive Problem CP5.4c
%----------------------------------------------------
clear,clf
disp('Comprehensive Problem 5.4c')
disp('Root-locus analysis of lead-lag controller ')
disp('...of hydro-turbine system')

hydro  % read data
disp('*****>'), pause

disp(' ')
disp('Hydro-turbine system with lead-lag controller, alpha = 20.')
disp('Lead zero at s = -3, Lag zero at s = -3/10 = -0.3') 
zlead = -3; zlag = zlead/10;
numleadlag = conv([1  -zlag],[1  -zlead]);
denleadlag = conv([1  -zlag/20],[1  -20*zlead]);
Gleadlag = tf(numleadlag,denleadlag)
G = tf(numG,denG)
G_OL = Gleadlag*G;
disp('*****>'), pause

disp('Run root-locus')
rlocus(G_OL)
grid
axis([-6 6 -6 6])
title('CP5.4c: Root-locus plot')

disp('use point to select a closed-loop pole')
[k,p] = rlocfind(G_OL)
keyboard

disp('An expanded root-locus plot')
axis([-2 2 -2 2])
keyboard

disp('Closed-loop system transfer functin for ')
disp('...the gain value selected')
T = feedback(k*G_OL,1)
disp('*****>'), pause

disp('Poles of closed-loop system')
pole(T)
disp('Zeros of closed-loop system')
tzero(T)
disp('DC gain of closed-loop system')
dcgain(T)
disp('*****>'), pause

disp('Step response of hydro-turbine to step reference input')
step(T)
title('CP5.4c:Closed-loop Response of Power P to Unit Step of Reference Input')
grid
keyboard

disp('end of Comprehensive Problem 5.4c')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
