%%%%%%%%%%%%%%%%%%%%%% p5_10.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%                   Problem 5.10:
%          root locus with omega_n varied
%
%                       K (0.2s+1)
%    G(s) = -----------------------------------
%           (tau s+1)(s^2 + 2 zeta wn s + wn^2)
%----------------------------------------------------
clear;clf
% do locus for  K=10, zeta=0.2, tau=4,
%      and 1 <= wn <= 10
K=10
tau=4
zeta=0.2
num=K*[0.2 1]
%
clpoles = []; param = []
for wn = 1:1:10,
   den = conv([tau 1],[1  2*zeta*wn  wn^2]);
   clpoly = [0 0 num] + den;  % form closed-loop char poly
   clp = roots(clpoly);  % calc closed-loop poles
   clpoles = [clpoles; clp'];
   param = [param;wn];
end
disp('values of omega_n and CL poles are:')
disp([param clpoles])
disp('****>')
pause
axis('square')
axis([-15 5 -10 10]);
plot(clpoles,'*')
grid;title('P5.10: Varying frequency')
xlabel('Real Axis')
ylabel('Imag Axis')
disp('end of Reinforcement Problem 5.10')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%