%%%%%%%%%%%%%%%%%%%%%% p5_12.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%                   Problem 5.12:
%       root locus with damping ratio zeta varied
%
%                         K (0.2s+1)
%     G(s) = -----------------------------------
%            (tau s+1)(s^2 + 2 zeta wn s + wn^2)
%----------------------------------------------------
clear;clf
%   do locus for  K=10,  wn=5, tau = 4 
%       and 0 <= zeta <= 1.0
K = 10
wn = 5
tau = 4
num=K*[0.2 1];
disp('******>');pause
clpoles = []; param = []
for zeta = 0:0.1:1.0,
   den = conv([tau 1],[1  2*zeta*wn  wn^2]);
   clpoly = [0 0 num] + den;  % form closed-loop char poly
   clp = roots(clpoly);  % calc closed-loop poles
   clpoles = [clpoles; clp'];
   param = [param;zeta];
end
disp('  zeta                CL poles ')
disp(' ')
disp([param clpoles])
disp('****>')
pause
axis('equal')
axis([-10 2 -6 6]);
plot(clpoles,'*');grid
title('P5.12: varying zeta')
text(-0.2,4.5,'zeta = 0')
text(-5.5,0.4,'zeta = 1.0')
disp('end of Reinforcement Problem 5.12')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%