%%%%%%%%%%%%%%%%%%%%% wif5_2.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 5/28/99 HS
%----------------------------------------------------
%	        What If for Example 5.2:
%		root locus with 4 poles, 1 zero
%---------------------------------------------------- 
clear,clf
disp('WhatIf? 5.2: Real and complex poles with variable zero')
  disp('  ')
  disp('                  K (s-Z)  ')
  disp('     G(s) = ------------------ ')
  disp('              s(s+2)(s^2+8s+32) ')
  disp('  ')
Z = input('Enter location of zero (-8 - Ex. 5.2) ==> ')
  disp('Create G(s) as ratio of polynomials')
  num = [1 -Z]          %- zero at s=Z
  temp2 = [1 8 32];     %- poles at s=-4+/-j4
  temp1 = [1 2 0];      %- poles at s=0, -2
  den = conv(temp1,temp2)
  G = tf(num,den)
  disp('*******>');pause
  disp('Draw root-locus plot with specified area ')
  disp('    Use axis command to adjust area for more detail')
  rlocus(G);grid
axis('equal')
text('Units','norm','Pos',[0.05 0.05],...
	'Str',['variable zero = ' num2str(Z)])
  title('WIF5.2: Root Locus')
keyboard
%--------------------
disp('Set zero to -2.6 and')
disp('....let MATLAB generate the gain vector')
disp('  ')
Z = -2.6
%--- Create G(s) as ratio of polynomials
  num = [1 -Z];          %- zero at s=Z
  temp2 = [1 8 32];     %- poles at s=-4+/-j4
  temp1 = [1 2 0];      %- poles at s=0, -2
  den = conv(temp1,temp2);
  G = tf(num,den)
disp('*******>');pause
rlocus(G);grid
title('WIF5.2: Root Locus, zero = -2.6')
axis('equal')
text('Units','norm','Pos',[0.05 0.05],...
	'Str',['variable zero = ' num2str(Z)])
keyboard
disp('now create gains to show intersections better')
k=logspace(1.5,1.9,100); % centered at k = 51
rlocus(G,k);grid
axis('equal')
axis([-6 2 -4 4])
title('WIF5.2: Root Locus, zero = -2.6')
text('Units','norm','Pos',[0.05 0.05],...
	'Str',['variable zero = ' num2str(Z)])
disp('end of What If 5.2')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%