%%%%%%%%%%%%%%%%%%%%%% cp6_1.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%  .M file for analyzing the power system example for 
%            Comprehensive Problem CP6.1
%----------------------------------------------------
clear,clf
disp('Comprehensive Problem CP6.1')

epow    % read data

disp('Power system transfer function, with V_term as output')
num = num1
den
G = tf(num,den)
disp('*****>'), pause

disp('zeros and poles of transfer function')
z = roots(num)
p = roots(den)
disp('*****>'), pause

disp('Make Bode plot')
clf
bode(G)
title('CP6.1: Bode plot of power system from E_fd to V_term')
keyboard

disp('Make Nichols plot')
clf
nichols(G)
title('CP6.1: Nichols plot of power system from E_fd to V_term')
grid
keyboard

disp('Make Nyquist plot')
clf
nyquist(G)
title('CP6.1: Nyquist plot of power system from E_fd to V_term')
keyboard

disp('Compute gain and phase margins')
margin(G)
keyboard

disp('Power system transfer function, with w(speed) as output')
num = num2
den
G = tf(num,den)
disp('*****>'), pause

disp('zeros and poles of transfer function')
z = roots(num)
p = roots(den)
disp('*****>'), pause

disp('Make Bode plot')
clf
bode(G)
title('CP6.1: Bode plot of power system from E_fd to w')
keyboard
subplot(1,1,1)

disp('Make Nichols plot')
clf
nichols(G)
title('CP6.1: Nichols plot of power system from E_fd to w')
grid
keyboard

disp('Make Nyquist plot')
clf
nyquist(G)
title('CP6.1: Nyquist plot of power system from E_fd to w')
axis([-0.1e-2 0 -1e-3 1e-3])
keyboard

disp('Compute gain and phase margins')
margin(G)

disp('end of Comprehensive Problem 6.1')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
