%%%%%%%%%%%%%%%%%%%%%% p6_5.m %%%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/9/99 HS
%----------------------------------------------------
%       Problem 6.5: simulate response due to 
%    sinusoidal input. Compute frequency response.
%----------------------------------------------------
  clear,clf
  disp('Problem 6.5: state-space model')
  disp(' ')
  disp('Enter transfer-function coefficients')
  A = [0 1 0;-4 -1 1;0 0 -20];
  B = [0;0;20];
  C = [1 0 0];
  D = [0]
  G = ss(A,B,C,D)
  disp('*****>');pause
  disp('Setting up t, u and y')
  t = [0:0.06:20]'; % time vector with 0.06 sec. increment
  u = 4*cos(2*t);  
  y = lsim(G,u,t);
  disp('magnitude and phase of frequency response at w = 0 rad/s')
  [mag,phase] = bode(G,2)  
  disp('*****>');pause
  disp('magnitude and phase of steady-state response')
  y_mag = 4*mag
  y_phase = 0 + phase
  y_ss = y_mag*cos (2*t + (y_phase)*pi/180);
  plot(t,u,'-',t,y,'--',t,y_ss,'-.')
  grid, title('P6.5 : u (solid), y (dashed) & yss (dashdot)')
  xlabel('Time in seconds')
  ylabel('u, y, yss')
  keyboard
  disp('end of Reinforcement Problem 6.5')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%