%%%%%%%%%%%%%%%%%%%%%% cp8_1.m %%%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/14/99 HS
%----------------------------------------------------
%   .M file for design P and PI controller for the 
%              power system example for 
%	     		  Comprehensive Problem CP8.1
%----------------------------------------------------
clear,clf
disp('Comprehensive Problem CP8.1')

epow    % read data

C = C(1,:);
cflag = input('enter 1 to add more damping to system ==> ')
if cflag == 1
  A(2,2) = 10*A(2,2); 
end

% transfer function from rectifier input to bus voltage
G = ss(A,B,C,0);
[num,den] = tfdata(G,'v');
disp('Power system transfer function, with V_term as output')
num = small20(num,1e-10);
den;
G = tf(num,den)
disp('*****>'), pause

disp('zeros and poles of transfer function')
pzmap(G)
grid;title('CP8.1: Pole-zero map')
keyboard

disp('Run root locus')
rlocus(G)
grid;title('CP8.1: Root-locus plot')
keyboard

disp('P controller design')
KP = 100
% closed-loop system
T = feedback(KP*G,1)
disp('See step response')
%
t=[0:0.02:20]';
step(T,t)
grid;title('CP8.1a: P controller step response')
y = step(T,t);
[Mo,tp,tr,ts,ess] = tstats(t,y,1)

keyboard

disp('PI controller design')
Kp = 30
Ki = 1/1.1
numK = Kp*[1 Ki]; denK = [1 0];
K = tf(numK,denK)
%
% closed-loop system
%
GK = K*G;

disp('See step response')
CLPI = feedback(GK,1)
step(CLPI,t)
y = step(CLPI,t);
grid;title('CP8.1b: PI controller step response')
[Mo,tp,tr,ts,ess] = tstats(t,y,1)

keyboard

disp('Compute uncompensated gain and phase margins')
margin(G)
keyboard

disp('Compute compensated gain and phase margins')
margin(GK)
keyboard
disp('end of Comprehensive Problem 8.1')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
