%%%%%%%%%%%%%%%% fig8_2b.m %%%%%%%%%%%%%%%
%
%	Does parameter sweep on KP
%  	Jan 99
%   last revision:  1/6/99  JHC
%----------------------------------------
clear
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 8.2(b):gain sweep, Prop control')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
denGp = conv([tauP1 1],[tauP2 1]);
Gp    = tf(Kproc,denGp)
H     = tf(1,[tau_sen 1])
%---------- open-loop transfer function
GpH   = Gp*H;
%------------- closed-loop step response to reference input
t = [0:0.02:10];
for KP = [0.7:0.2:1.7];
  T = feedback(KP*Gp,H,-1)
  ys = step(T,t);
  plot(t,ys)
  if ishold ~=  1, hold on, end
end
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
%title('fig 8.2(b):CL step response, P-only, ref input, Ex 8.1')
text(5.0,0.25,'KP = 0.7,0.9, ... ,1.7')
text(6.0,0.70,'KP = 0.7')
text(6.0,0.92,'KP = 1.7')
axis([0 10 0 1.2])
hold off
print -deps fig8_2b.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%