%%%%%%%%%%%%%%%% fig8_5.m %%%%%%%%%%%%%%%
%
%      2nd order plant with 2 real poles with P-I control
% 	runs reference & disturbance step response for
%  	Jan 99
%   last revision:  1/6/99  JHC
%----------------------------------------
clear
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('fig 8.5: PI control')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
denGp = conv([tauP1 1],[tauP2 1]);
Gp    = tf(Kproc,denGp)
H     = tf(1,[tau_sen 1])
%=========== reference input ===========
KP = 0.6;	% selected for 10% overshoot
KP_str=num2str(KP);
KI = 0.5;
KI_str=num2str(KI);
Kc = tf(KP*[1 KI],[1 0]);
[T_ref] = feedback(Gp*Kc,H,-1);
t = [0:0.02:10];
y_ref = step(T_ref,t);

%=========== repeat for disturbance input ===========
T_dist = feedback(Gp,-Kc*H,+1);
y_dist = step(T_dist,t);
%-------- plot both responses
plot(t,y_ref,t,y_dist,'--')
axis([0 10 0 1.2])
xlabel('Time (sec.)'),ylabel('Amplitude')
grid;
%title('fig 8.5: CL ref & dist step responses, P-I control')
text(6.0,0.55,['KP = ' KP_str])
text(6.0,0.45,['KI = ' KI_str])
text(7.0,1.05,'reference')
text(6.0,0.15,'disturbance')
print -deps fig8_5.eps
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%