%%%%%%%%%%%%%%%%%%%%% wif8_3a.m %%%%%%%%%%%%%%%%%%%%%
%       Feedback Control Problems with MATLAB
%           and the Control System Toolbox
%      D. K. Frederick and J. H. Chow, May 1999
%             last revision: 6/16/99 HS
%----------------------------------------------------
%  This MATLAB file runs the What-if problem after 
%  						Example 8.3
%----------------------------------------------------
clear,clf
disp('Wif 8.3a: PID control')

%----- plant & sensor parameters
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4;
numGp = Kproc;
denGp = conv([tauP1 1],[tauP2 1]);
H     =tf(1,[tau_sen 1]);

%============== Part (a): sweep KP for various KI values
KP = 1;
KI = 0.5;
KI_str=num2str(KI);
denGc = [1 0];
denG = conv(denGc,denGp);

%=============== Part (b): root locus =============
disp('root locus for KD = 0.3')
KD = 0.3;
KD_str=num2str(KD);
%-- Note: can not use series cmd because Gc(s) is not proper
%   Also, can not use: numRL = conv([KD 1 KI],numGpH);
%      to form numerator because  numGpH has been padded
%      with 3 leading zeros, causing a bogus error message
%      from the MATLAB routine tfchk
    numKc = KP*[KD 1 KI];   % numerator of PID controller
    numGK = conv(numKc,numGp);
    GK = tf(numGK,[denGp 0])
    disp('draw root locus with default area')
    rlocus(GK*H); grid
axis equal
title('Wif 8.3a: open-loop, PID control, KD = 0.3')
text(20,-10,['KI = ' KI_str])
text(20,-15,['KD = ' KD_str])
keyboard
disp('redraw locus with smaller area')
axis([-15 5 -10 10])
title('Wif 8.3a: open-loop, PID control, KD = 0.3')
text(0,-5,['KI = ' KI_str])
text(0,-6,['KD = ' KD_str])
keyboard
disp('redraw locus with still smaller area')
axis([-2.5 0.5 -1.2 1.2])
title('Wif 8.3a: open-loop, PID control, KD = 0.3')
text(-0.2,-0.85,['KI = ' KI_str])
text(-0.2,-1.0,['KD = ' KD_str])
keyboard
[kk,polesCL] = rlocfind(GK*H)

disp('root locus for KD = 0.5')
KD = 0.5;
KD_str=num2str(KD);
%-- Note: can not use series cmd because Gc(s) is not proper
%   Also, can not use: numRL = conv([KD 1 KI],numGpH);
%      to form numerator because  numGpH has been padded
%      with 3 leading zeros, causing a bogus error message
%      from the MATLAB routine tfchk
    numKc = KP*[KD 1 KI];   % numerator of PID controller
    numGK = conv(numKc,numGp);
    GK = tf(numGK,[denGp 0])
    disp('draw root locus with default area')
    rlocus(GK*H); grid
axis equal
title('Wif 8.3a: open-loop, PID control, KD = 0.5')
text(20,-10,['KI = ' KI_str])
text(20,-15,['KD = ' KD_str])
keyboard
disp('redraw locus with smaller area')
axis([-15 5 -10 10])
title('Wif 8.3a: open-loop, PID control, KD = 0.5')
text(0,-5,['KI = ' KI_str])
text(0,-6,['KD = ' KD_str])
keyboard
disp('redraw locus with still smaller area')
axis([-2.5 0.5 -1.2 1.2])
title('Wif 8.3a: open-loop, PID control, KD = 0.5')
text(-0.2,-0.85,['KI = ' KI_str])
text(-0.2,-1.0,['KD = ' KD_str])
keyboard
[kk,polesCL] = rlocfind(GK*H)

disp('end of What If 8.3a')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%