%%%%%%%%%%% fig9_5.m %%%%%%
% 	Jan. 99
%  last revision:  1/8/99  JHC
%----------------------------------------
clear;clf
set(gcf,'DefaultAxesFontSize',16)
set(gcf,'DefaultTextFontSize',16)
disp('Fig 9.5: initial Bode plot for Ex. 9.2')
tauP1 = 2; tauP2 = 0.5; tau_sen = 0.05; Kproc = 4; 
ess_des = 0.02;
Kp_des = (1/ess_des) - 1;
%-----
Gp = tf(Kproc,conv([tauP1 1],[tauP2 1]));
H  = tf(1,[tau_sen 1]);
GpH = Gp*H;
plant_lfg = dcgain(GpH);
Klag = Kp_des/plant_lfg;
%-------------- open-loop frequency response
w = logspace(-1,1,100);
ph180 = -180*ones(length(w));
[mag,ph] = bode(Klag*GpH,w);
mag   = reshape(mag,100,1);
ph    = reshape(ph, 100,1);
mag_db = 20*log10(mag);
subplot(211)	%------ magnitude plot
semilogx(w,mag_db);grid
%title('fig 9.5: plant + gain to give desired ess, Ex 9.2')
xlabel('Frequency (rad/sec)')
ylabel('Gain dB')
hold on
x1 = [1.57 1.57];y1 = [10 35];
x2 = [0.80 2.5]; y2 = [21.3 21.3];
line(x1,y1)
line(x2,y2)
text(0.20,20.0,'11.64 = 21.3 dB')
text(1.30,0,'1.57 rad/sec')
hold off
subplot(212)	%------ phase plot
semilogx(w,ph,w,ph180);grid
xlabel('Frequency (rad/sec)')
ylabel('Phase deg')
hold on
semilogx(w,ph180,'--')
x3 = [1.57 1.57]; y3 = [-160 -50];
x4 = [0.80 2.5]; y4 = [-115 -115];
line(x3,y3)
line(x4,y4)
text(1.30,-30,'1.57 rad/sec')
text(0.35,-110,'-115 deg')
text(0.12,-165,'-180 deg')
hold off
print -deps fig9_5.eps
subplot(111)
%-- reset fonts to defaults
set(gcf,'DefaultAxesFontSize',get(0,'DefaultAxesFontSize'));
set(gcf,'DefaultTextFontSize',get(0,'DefaultTextFontSize'));
%%%%%%